/*{{{  possible switches*/
/*
   Use the following configuration symbols to generate a makefile for
   your system with "/usr/lib/cpp -DCONFIG Makefile.cpp >Makefile"

   SUNOS_UNPROTO_CC
   SUNOS_GCC
   HPUX_UNPROTO
   HPUX_ANSI
   LINUX
   MINIX_BCCi386  (untested)
   MINIX_GCCi386  (untested)
   MIPS           (untested)

   If you call keybind with option -r<file>, it will generate a reference
   card when compiling the keybinding.  Since we never used reference cards,
   this option is not set anywhere in the rules.

*/
/*}}}  */
/*{{{  SUNOS*/
#if (defined(SUNOS_UNPROTO_CC) || defined(SUNOS_GCC))
ORIGAMI_PATH=   $(HOME)/origami
RC_PATH=        $(HOME)/origami
TERMINALS=      xterm s\un mgr
MODEORIFLAG=    -M xterm
#endif
/*}}}  */
/*{{{  HPUX*/
#if (defined(HPUX_UNPROTO) || defined(HPUX_ANSI) )
ORIGAMI_PATH=   $(HOME)/origami
RC_PATH=        $(HOME)/origami
TERMINALS=      vt100 xterm
MODEORIFLAG=    -M xterm
#endif
/*}}}  */
/*{{{  MINIX, LINUX*/
#if (defined(MINIX_BCCi386) || defined(MINIX_GCCi386) || defined(LINUX))
ORIGAMI_PATH=   /usr/local/origami
RC_PATH=        /usr/local/origami
TERMINALS=	$(TERM)
MODEORIFLAG=    -U BASE
#endif
/*}}}  */
/*{{{  MIPS*/
#if defined(MIPS)
ORIGAMI_PATH=   $(HOME)/origami
RC_PATH=        $(HOME)/origami
TERMINALS=      vt100 xterm
MODEORIFLAG=    -M xterm
#endif
/*}}}  */

install:        deinstall term
		install -d $(ORIGAMI_PATH)/bindings/fun
		install -d $(ORIGAMI_PATH)/bindings/vi-fun
		install -d $(ORIGAMI_PATH)/bindings/modeori-fun
		install -d $(ORIGAMI_PATH)/bindings/emacs-fun
		install *.keys $(ORIGAMI_PATH)/bindings
		install fun/?* $(ORIGAMI_PATH)/bindings/fun
		install vi-fun/?* $(ORIGAMI_PATH)/bindings/vi-fun
		install modeori-fun/?* $(ORIGAMI_PATH)/bindings/modeori-fun
		install emacs-fun/?* $(ORIGAMI_PATH)/bindings/emacs-fun
		install termalias termlist $(ORIGAMI_PATH)/bindings
		rm termalias termlist

bindinstall:	eminstall moinstall mtinstall

term:
		echo "; This file is generated by autoalias(1)" >termalias
		for i in $(TERMINALS); do autoalias -t $$i >>termalias; done
		echo "; This file is generated by autoalias(1)" >termlist
		echo "(" >termlist
		echo $(TERMINALS) >>termlist
		echo ")" >>termlist

eminstall:	emacs
		install -d $(RC_PATH)
		install .origamirc $(RC_PATH)
		install .c-rc $(RC_PATH)

emacs:		term
		keybind -sOR -U TERM -o .origami emacs.keys
		keybind -sOR -U TERM -U c-mode -o .c- emacs.keys
		rm termalias termlist

modeori:
		keybind -sOR $(MODEORIFLAG) -o .modeori modeori.keys

moinstall:	modeori
		install -d $(RC_PATH)
		install .modeorirc $(RC_PATH)

mtorigami:
		keybind -s -o .mtorigami mtool.keys

mtinstall:	mtorigami
		install -d $(RC_PATH)
		install .mtorigamirc $(RC_PATH)

deinstall:
		rm -rf $(ORIGAMI_PATH)/bindings
		rm -f $(RC_PATH)/.origamirc
		rm -f $(RC_PATH)/.c-rc
		rm -f $(RC_PATH)/.modeorirc
		rm -f $(RC_PATH)/.mtorigamirc

clobber:
		rm -f Makefile termalias termlist .*rc
