.\"{{{  Notes
.\" This file will be included by origami.ms and is not for seperate use
.\"}}}
.NH 1
All Origami functions
.LP
This chapter lists all Origami functions with their keybind names.
If you want to create a new
keybinding, regard the Emacs-like and the TDS binding as examples.
.\"{{{  moving around
.NH 2
Moving around
.\"{{{  backward-character
.LP
\fBbackward-character\fP
.\"}}}
.\"{{{  forward-character
.LP
\fBforward-character\fP
.\"}}}
.\"{{{  previous-line
.LP
\fBprevious-line\fP
.\"}}}
.\"{{{  next-line
.LP
\fBnext-line\fP
.\"}}}
.\"{{{  beginning-of-line
.LP
\fBbeginning-of-line\fP
.\"}}}
.\"{{{  end-of-line
.LP
\fBend-of-line\fP
.\"}}}
.\"{{{  previous-page
.LP
\fBprevious-page\fP
.\"}}}
.\"{{{  next-page
.LP
\fBnext-page\fP
.\"}}}
.\"{{{  beginning-of-fold
.LP
\fBbeginning-of-fold\fP
.SP
Moves to the beginning of the entered fold.
.\"}}}
.\"{{{  end-of-fold
.LP
\fBend-of-fold\fP
.SP
Moves to the end of the entered fold.
.\"}}}
.\"{{{  goto-line
.LP
\fBgoto-line\fP
.SP
Prompts for a line number and moves cursor to this line.  If needed,
Origami opens closed folds to reach this line.
.SP
.I Warning:
The lines are counted beginning at start of file.  Origami exits entered
folds and moves to the given position.  Older versions than 1.6.17 used
top of entered folds as starting point for counting!
.\"}}}
.\"}}}
.\"{{{  folding
.NH 2
Folding
.\"{{{  open-fold
.LP
\fBopen-fold\fP
.SP
Open fold and show the contents in the context of the current level.
.SP
Unlike TDS, you can not open file folds, just entering them is allowed.
.\"}}}
.\"{{{  close-fold
.LP
\fBclose-fold\fP
.SP
If the cursor is located within an opened fold, close this fold.
.\"}}}
.\"{{{  enter-fold
.LP
\fBenter-fold\fP
.SP
Enter the fold at the current line.  Entering a filed fold saves the
current file and switches to the new one.  The old file and the line are
stored internally.  file!
.SP
Unlike TDS, using this function on normal text lines is allowed.
Origami uses the string between the cursor position and the next single
quote, double quote or whitespace as filename.  If Origami cannot open
the file, it will prompt for a filename (empty filename uses current
file!).  The file will be entered as if there was a filed fold for it.
.SP
.I N.B
This command should be renamed `push-file', but we decided to keep the
old name for historical reaons.
.\"}}}
.\"{{{  exit-fold
.ne 2
.LP
\fBexit-fold\fP
.SP
Exit fold.  Exiting a filed fold saves it.
.\"}}}
.\"{{{  unfold-fold
.LP
\fBunfold-fold\fP
.SP
Remove fold at the current line \(em deletes the fold structure and
inserts the contents of the fold instead.
.\"}}}
.\"{{{  create-fold
.LP
\fBcreate-fold\fP
.SP
Create fold.  Use twice \(em first to indicate the top of a new fold,
then to indicate its bottom.  Lines to be included within the fold
must not be indented less than the fold itself.  Tabs are not allowed at the
beginning of the folded lines if they appear before the intended indentation of
the fold.  Several other keys are disabled while create-fold is active.
.SP
.I Warning:
Using this function on the begin fold line of an opened fold will display
the new begin fold line at cursor position 1, though the fold will be
created at the intended position.
.\"}}}
.\"{{{  auto-header
.LP
\fBauto-header\fP
.SP
When the cursor is on a closed fold this key will copy the first line
enclosed by that fold to the fold line.
.\"}}}
.\"{{{  toggle-file-fold
.LP
\fBtoggle-file-fold\fP
.SP
File (create a new file) or unfile a fold.  Creating a file writes the
contents of the fold into a new file named by the fold comment (up to
the first whitespace).  Unlike TDS Origami does not create a new
filename, if the chosen one is already used.  It doesn't matter if you
change the fold comment after filing a fold, because the filename is
stored internally.  Unfiling a filed fold replaces the file link with
the contents of the file itself.  Unlike TDS Origami doesn't remove the
original file included this way.
.\"}}}
.\"{{{  attach-file-to-fold
.LP
\fBattach-file-to-fold\fP
.SP
Attach a file to a fold.  This function links an existing file rather than
creating a new one (and thus differs from toggle-create-file-fold).  The
filename is taken from the comment of the empty fold the cursor is
placed on.  The filename starts behind the foldmark and ends at the
first whitespace.  The rest of the line is ignored.
After attaching files you can change the fold header because the file information
is stored internally.
.SP
Unlike TDS, this function cannot be used to \fBdetach\fP a filed fold.
.\"}}}
.\"}}}
.\"{{{  editing
.NH 2
Editing
.\"{{{  delete-to-end-of-line
.LP
\fBdelete-to-end-of-line\fP
.SP
Delete to end of line.  There is no `undo' for this operation.
.\"}}}
.\"{{{  delete-line
.LP
\fBdelete-line\fP
.SP
Transfers the current line to the delete buffer, overwriting its old
contents.
.\"}}}
.\"{{{  undo-delete-line
.LP
\fBundo-delete-line\fP
.SP
Inserts the line currently stored in the delete buffer as previous line.
This can be done for exactly one line.
.\"}}}
.\"{{{  delete-character
.LP
\fBdelete-character\fP
.SP
Delete character under the cursor.  If the cursor was at end of line,
the next line will be appended to this line.
.\"}}}
.\"{{{  delete-previous-character
.LP
\fBdelete-previous-character\fP
.SP
Deletes the character to the left of the cursor.  If the cursor was at
the left margin, this line will be appended to the previous line.
.\"}}}
.\"{{{  undo-delete-character
.LP
\fBundo-delete-character\fP
.SP
Undeletes the last deleted character.  This stored character is only
changed by the \fBdelete-character\fP or \fBdelete-previous-character\fP
commands.
.\"}}}
.\"{{{  transpose-characters
.LP
\fBtranspose-characters\fP
.SP
Transposes the character left of the cursor with the character under the
cursor and moves the cursor right one character.
.\"}}}
.\"{{{  toggle-case
.LP
\fBcase-character-toggle\fP
.SP
Changes the case of the character under the cursor.
.\"}}}
.\"{{{  newline-and-indent
.LP
\fBnewline-and-indent\fP
.SP
Opens the line at cursor position and indents the right part like the
left part.  For fold comments, this only works at end of line.
.\"}}}
.\"{{{  kill-line
.LP
\fBkill-line\fP
.SP
Removes a line from the file and adds it to the end of the kill buffer.
Note that the `kill buffer' is lost when exiting Origami, unlike TDS.
.\"}}}
.\"{{{  copy-to-kill-buffer
.LP
\fBcopy-to-kill-buffer\fP
.SP
Copies a line to the end of the kill buffer without deleting it from the
file.  Note that the kill buffer is lost when exiting Origami, unlike
TDS.  Lines containing filed folds cannot be copied to the kill buffer.
.\"}}}
.\"{{{  insert-folded-kill-buffer
.LP
\fBinsert-folded-kill-buffer\fP
.SP
Places the kill buffer before the current line as a fold with no
comment.
.\"}}}
.\"{{{  move-line
.LP
\fBmove-line\fP
.SP
If the move buffer is empty, the current line is moved to the move
buffer.  Otherwise the move buffer is inserted before the current line.
Note that the move buffer is lost when exiting Origami, unlike TDS.
.\"}}}
.\"{{{  double-line
.LP
\fBdouble-line\fP
.SP
Duplicates the current line in the file.  Lines containing filed folds
cannot be duplicated.
.\"}}}
.\"}}}
.\"{{{  search & replace
.NH 2
Search and replace
.\"{{{  search-forward
.LP
\fBsearch-forward\fP
.SP
Prompts for a search string and displays its next occurence.  An empty
search string repeats the last search.  The pattern is searched in the
currently entered fold.
.\"}}}
.\"{{{  search-reverse
.LP
\fBsearch-reverse\fP
.SP
Same as \fBsearch-forward\fP, but searches backward.
.\"}}}
.\"{{{  replace-string
.LP
\fBreplace-string\fP
.SP
Asks for a search and a replace string and replaces all occurences.  The
replace will be done in the currently entered fold.
.\"}}}
.\"{{{  quere-replace-string
.LP
\fBquery-replace-string\fP
.SP
Same as \fBreplace-string\fP, but asks before replacing.
.\"}}}
.\"{{{  incremental-search
.LP
\fBincremental-search-forward\fP
.SP
Searches the text for a string.  String can be entered incrementally.
\fBdelete-character-backward\fP jumps to the position where the
character was added to the search string.  Adding a character tries to
find the new string.  Aborting this command jumps to the calling
position.  \fBnewline-and-indent\fP ends the search.
\fBprevious-line\fP, \fBprevious-character\fP,
\fBincremental-search-reverse\fP and \fBsearch-reverse\fP switch the
search direction to backwards and search the string.  \fBnext-line\fP,
\fBforward-character\fP, \fBincremental-search\fP and
\fBsearch-forward\fP switch the search direction to forward and search
the string.  The pattern is searched in the currently entered fold.
.SP
.I N.B.
using \fBprevious-character\fP, \fBincremental-search-reverse\fP,
\fBsearch-reverse\fP, \fBnext-line\fP, \fBforward-character\fP,
\fBincremental-search\fP, \fBsearch-forward\fP or
\fBdelete-character-backward\fP as first input inside the
incremental search initialises the search pattern with the last used
pattern.  Using \fBincremental-search-forward\fP uses \fBgoto-line\fP to
move to the old position if lines are different, so that opened folds are
not closed automatically!
.LP
\fBincremental-search-reverse\fP
.SP
Same as \fBincremental-search\fP, but starts with search direction
backwards.
.\"}}}
.\"}}}
.\"{{{  files
.NH 2
Files
.\"{{{  read-file
.LP
\fBread-file\fP
.SP
Reads another file for editing, saving the current one if required.  If
no filename is given, the current file is reread.
.SP
.I N.B
Using \fBprevious-file\fP or \fBnext-file\fP after using \fBread-file\fP
\fIfile\fP jumps back in the given command line file list.  \fIfile\fP
is not added to this list!
.\"}}}
.\"{{{  next-file
.LP
\fBnext-file\fP
.SP
Read next file given in the command line, saving the current file if required.
.SP
.I Warning:
Using this function inside a filed fold will return to the toplevel fold!
.\"}}}
.\"{{{  previous-file
.LP
\fBprevious-file\fP
.SP
Read previous file given in command line, saving the current one if
required.
.SP
.I Warning:
Using this function inside a filed fold will return to the toplevel fold!
.\"}}}
.\"{{{  save-file
.LP
\fBsave-file\fP
.SP
Saves the current file with the current name and language.  This command will
only succeed if you haven't entered a fold.
.SP
N.B If Origami is in view mode, the file will not be saved, even if
it was changed.
.\"}}}
.\"{{{  write-file
.LP
\fBwrite-file\fP
.SP
Prompts for a filename and listing-mode.  If no filename is given, the
current filename will be used.  Origami writes the text to a new file
using the current language.  If listing-mode is set, the generated file
will be modified in the following way:
.DS
no heading \fIcomment\fP \fB{\&{\&{}\&}\&}\fP \fIcomment\fP line
no \fB{\&{\&{\fP in fold headers
no \fIcomment\fP \fB}\&}\&}\fP \fIcomment\fP lines
.DE
If listing-mode is set, the fold structure in the written file is
lost.  While using the language \fBInmos\fP it is impossible to set
listing-mode, because the the generated files have an incompatible
structure.
.\"}}}
.\"{{{  insert-file
.LP
\fBinsert-file\fP
.SP
Insert File.  Prompts for a filename and imports this file into the
edited file at the current position.  If no filename is given, the
current filename is used.
.\"}}}
.\"{{{  filter-buffer
.LP
\fBfilter-buffer\fP
.SP
Filters the current text.  Origami prompts for the name of a filter.
The current text is saved and piped through this filter.  Origami tries
to move the cursor back to the line on which the cursor was placed
before executing this command.  The exit code of the called command is
stored in the OCL-variable \fBocl-argument\fP (\-1, if no correct value
can be given).  Environment variables \fBORIFILE\fP, \fBORILINE\fP and
\fBORIWORD\fP are set to current filename, textline and word.  Word is
the sequence of \fBa\fP..\fBzA\fP..\fBZ_\fP, where the cursor stands on.
Environment variables \fBORIXPOS\fP and \fBORIYPOS\fP are set to x
position (characters 1,..) and y position (line 1,..) in file.
Environment variable \fBORIPID\fP is set to \fBOrigami\fP's process id.
.SP
.I Warning:
The line count begins at start of file.  Older versions than 1.6.17
used top of entered folds as starting point for counting!
.\"}}}
.\"{{{  pipe-from-command
.LP
\fBpipe-from-command\fP
.SP
Prompts for a command.  The command is executed and its standard output
inserted in the text at current position.  The exit code of the called
command is stored in the OCL-variable \fBocl-argument\fP (\-1, if no
correct value can be given).  Environment variables \fBORIFILE\fP,
\fBORILINE\fP and \fBORIWORD\fP are set to current filename, textline
and word.  Word is the sequence of \fBa\fP..\fBzA\fP..\fBZ_\fP, where
the cursor stands on.  Environment variables \fBORIXPOS\fP and
\fBORIYPOS\fP are set to x position (character 1,..) and y position
(line 1,..) in file.  Environment variable \fBORIPID\fP is set to
\fBOrigami\fP's process id.
.SP
.I Warning:
The line count begins at start of file.
.\"}}}
.\"{{{  pipe-to-command
.LP
\fBpipe-to-command\fP
.SP
Prompts for a command.  The current file will be piped to this command
as standard input.  The exit code of the called command is stored in the
OCL-variable \fBocl-argument\fP (\-1, if no correct value can be given).
Environment variables \fBORIFILE\fP, \fBORILINE\fP and \fBORIWORD\fP are
set to current filename, textline and word.  Word is the sequence of
\fBa\fP..\fBzA\fP..\fBZ_\fP, where the cursor stands on.  Environment
variables \fBORIXPOS\fP and \fBORIYPOS\fP are set to x position
(character 1,..) and y position (line 1,..) in file.  Environment
variable \fBORIPID\fP is set to \fBOrigami\fP's process id.
.\"}}}
.\"}}}
.\"{{{  macros
.NH 2
Macros
.\"{{{  define-macro
.LP
\fBdefine-macro\fP
.SP
Records all keys into the keyboard macro buffer until define-macro is
pressed again.  Calling fix-macros is allowed during define-macro. This
function cannot be executed while Origami prompts for information for another
function (like \fBread-file\fP).
.\"}}}
.\"{{{  execute-macro
.LP
\fBexecute-macro\fP
.SP
Call keyboard macro.
.\"}}}
.\"{{{  save-keyboard-macro
.LP
\fBsave-keyboard-macro\fP
.SP
Asks for the number of a fix macro buffer.  The contents of the keyboard
macro buffer is copied to this fix macro buffer.  Using \fB(deffun \&..
)\fP in keybind makes it impossible to overwrite the fix buffer.  Using
\fB\&(defusermacros\fP \fIx\fP\fB)\fP in your OCL source places \fIx\fP free
macro buffers at places 1..\fIx\fP.
.\"}}}
.\"{{{  execute-number-macro n
.LP
\fBexecute-number-macro\fP \fIn\fP, (\fIn\fP=1,2,..)
.SP
Execute fix-macro number \fIn\fP.  This command should be used to call
macros defined by \fBsave-keyboard-macro\fP.  All other macro buffers
are used by \fB(deffun\fP \fIfoo\fP \fB(...) )\fP and \fB(keybind\fP
\fIfoo\fP \fB(...) )\fP in keybind, so that using these operations has
the same effect as calling the macro keysequence by their name!
.\"}}}
.\"}}}
.\"{{{  shell commands
.NH 2
Shell commands
.\"{{{  shell
.LP
\fBshell\fP
.SP
Creates a shell according to the environment variable \fBSHELL\fP.
Exiting from this shell will return to Origami.  The exit code of the
shell is stored in the \fBOCL\fP-variable \fBocl-argument\fP.  It's
\fB\-1\fP, if no correct value can be given.  Environment variables
\fBORIFILE\fP, \fBORILINE\fP and \fBORIWORD\fP are set to current
filename, textline and word.  Word is the sequence of
\fBa\fP..\fBzA\fP..\fBZ_\fP, where the cursor stands on.  Environment
variables \fBORIXPOS\fP and \fBORIYPOS\fP are set to x position
(charater 1,..) and y position (line 1,..) in file.  Environment
variable \fBORIPID\fP is set to \fBOrigami\fP's process id.
.\"}}}
.\"{{{  shell-command
.LP
\fBshell-command\fP
.SP
Prompts for a command and starts a shell which executes it.  Environment
variables \fBORIFILE\fP, \fBORILINE\fP and \fBORIWORD\fP are set to
current filename, textline and word.  Word is the sequence of
\fBa\fP..\fBzA\fP..\fBZ_\fP, where the cursor stands on.  The exit code
of the shell is stored in the \fBOCL\fP-variable \fBocl-argument\fP.
It's \fB\-1\fP, if no correct value can be given.  Environment variables
\fBORIXPOS\fP and \fBORIYPOS\fP are set to x position (character 1,..)
and y position (line 1,..) in file.  Environment variable \fBORIPID\fP
is set to \fBOrigami\fP's process id.
.\"}}}
.\"{{{  suspend-origami
.LP
\fBsuspend-origami\fP
.SP
If your system has job control, Origami will be stopped and the calling
shell is reactivated.
.\"}}}
.\"}}}
.\"{{{  arguments
.NH 2
Arguments
.LP
Like in Emacs, you can repeat each command by using an numerical
argument.  The first digit is given by \fBset-argument-\fP\fIdigit\fP.  These
functions read more digits of the argument until you type a non digit.
This non digit may be a key sequence bound to a command or just a single
character.  It will be repeated argument times.  Pressing the
abort key will abort the repeated execution.  \fBset-argument \fP\fIx\fP stops the
definition or execution of a keyboard macro!
.LP
\fBset-argument-0\fP ... \fBset-argument-9\fP
.LP
If the argument is set to 0, the command will be executed once.
.\"}}}
.\"{{{  special functions
.NH 2
Special functions
.\"{{{  quote-character
.LP
\fBquote-character\fP
.SP
The next character typed in will be inserted in your text, even if it is
bound to a command.
.\"}}}
.\"{{{  redraw-display
.LP
\fBredraw-display\fP
.SP
Refresh the screen.  This is especially useful if the screen was messed up
by messages...
.\"}}}
.\"{{{  center-and-redraw-display
.LP
\fBcenter-and-redraw-display\fP
.SP
Refresh and center screen.  Like \fBredraw-display\fP, but also resets the
window size.  If you are working with a window environment
which does not send a window changed signal, you may use this command
after resizing a window.
.\"}}}
.\"{{{  help
.LP
\fBhelp\fP
.SP
Displays the helpfile $HOME/.origamihelp.  Since there is no default
file for this function, you can create your own helpfile.  It may be
useful for new and very complicated macros or other things you always
forget.  If there is no file $HOME/.origamihelp, Origami tries to get
the referencedata from rc file.
.\"}}}
.\"{{{  describe-bindings
.LP
\fBdescribe-bindings\fP
.SP
Displays the binding information stored in $HOME/.origamirc.  All
currently recognized keyboard inputs will be printed.
.\"}}}
.\"{{{  set-language
.LP
\fBset-language\fP
.SP
Allows you to select the language for which the code is to be saved \(em
ie the format in which folds are to be saved.  This can be done by
entering the first character of the language or by using
\fBforward-character\fP, \fBbackward-character\fP.  The currently used
language is displayed inverse.  If you choose \fBUser\fP, Origami prompts
for the begin comment and end comment strings used for hiding the fold
comments.  Each string can be up to three characters in length.
.SP
.I N.B
If the current language is \fBInmos\fP, Origami prompts for permission,
to prevent destruction of internal Inmos information.
.\"}}}
.\"{{{  describe-fold
.LP
\fBdescribe-fold\fP
.SP
Displays information on current cursorposition in file, number of
entered folds in current file, indentation of currently entered fold and
maybe information about the closed foldline under the cursor.  The fold
information is a pair of numbers.  The first number describes the fold
type and the second the fold contents (range 0..255).  These codings
have specific meanings in TDS. The OCL-variable \fBocl-argument\fP is
set to:
.TS
tab(|);
l l.
coding:|condition:
256*type+contents|if type<128
-(256*(type mod 128)+contents)|otherwise
.TE
.\"}}}
.\"{{{  modes
.\"{{{  set-file-unchanged
.LP
\fBset-file-unchanged\fP
.SP
Marks the file as unchanged.
.\"}}}
.\"{{{  edit/view
.LP
\fBadd-mode-view\fP
.SP
Sets view only mode.
.LP
\fBdelete-mode-view\fP
.SP
Sets edit mode.
.\"}}}
.\"{{{  insert/overwrite
.LP
\fBadd-mode-overwrite\fP
.SP
Sets overwrite mode.  Text input will overwrite other text.
.LP
\fBdelete-mode-overwrite\fP
.SP
Sets insert mode.  Text input will be inserted.
.\"}}}
.\"{{{  echo on/off
.LP
\fBadd-mode-echo\fP
.SP
Incomplete keysequences are displayed under the status line.
.LP
\fBdelete-mode-echo\fP
.SP
Do not show unfinished keysequences.
.\"}}}
.\"{{{  auto-save on/off
.LP
\fBadd-mode-auto-save\fP
.SP
Prompts for the auto save interval.  Origami will save your files
periodically in auto save mode.  Default time is 8 minutes.  Minimum is
2 minutes and maximum is 60 minutes.
.LP
\fBdelete-mode-auto-save\fP
.SP
auto save is switched off.
.\"}}}
.\"{{{  status-line-off
.LP
\fBstatus-line-off\fP
.SP
Displaying the status line is disabled.
.\"}}}
.\"{{{  status-line-on
.LP
\fBstatus-line-on\fP
.SP
Displaying the status line is enabled.
.\"}}}
.\"{{{  numeric-keypad
.LP
\fBnumeric-keypad\fP
.SP
Switches your keypad to numeric mode, if your terminal supports it.
.\"}}}
.\"{{{  application-keypad
.LP
\fBapplication-keypad\fP
.SP
Switches your keypad to application mode, if your terminal supports it.
.\"}}}
.\"}}}
.\"{{{  pipe-kbd-from-command
.LP
\fBpipe-kbd-from-command\fP
.SP
Prompts for a command.  This command will be executed and its standard
output will be read as keyboard input for Origami.  Using this, while
another \fBpipe-kbd-from-command\fP is active will close all pipes! The
exit code of the called command is stored in the OCL-variable
\fBocl-argument\fP (\-1, if no correct value can be given).  Environment
variables \fBORIFILE\fP, \fBORILINE\fP and \fBORIWORD\fP are set to
current filename, textline and word.  Word is the sequence of
\fBa\fP..\fBzA\fP..\fBZ_\fP, where the cursor stands on.  Environment
variables \fBORIXPOS\fP and \fBORIYPOS\fP are set to x position
(character 1,..) and y position (line 1,..) in file.  Environment
variable \fBORIPID\fP is set to \fBOrigami\fP's process id.  The general
abort key stops the reading from a pipe.
.\"}}}
.\"{{{  no-operation
.LP
\fBno-operation\fP
.SP
No operation.  This command can be used to explicitly disable keyboard
inputs.
.\"}}}
.\"{{{  bell
.LP
\fBbell\fP
.SP
Activates the bell of your terminal.
.\"}}}
.\"{{{  visible-bell
.LP
\fBvisible-bell\fP
.SP
Activates the `visible bell' of your terminal.
.\"}}}
.\"{{{  abort
.LP
\fBabort\fP
.SP
Aborts any operation.  There are several commands which can be aborted
by this key.  This operation can only be bound to a single key.  This
key will even stop a running macro, which may be useful to interrupt an
endless loop.  If you are anxious Origami might be doing something
wrong, this key returns you to a safe state.  \fBabort\fP can abort the
reading of ASCII files (by simulating a \fBeof\fP) for the following
commands:
.\"{{{  table of commands
.TS
tab(|);
l l.
Command:|condition:
\fBenter-fold\fP|a filed fold
\fBexit-fold\fP|a filed fold
\fBfile-fold\fP|used to unfile a filed fold
\fBinsert-file\fP
\fBfilter-buffer\fP
\fBpipe-from-command\fP
reading the startup file|edit-file and stdin-pipe
.TE
.\"}}}
.SP
For technical reasons, this doesn't work for reading files in
\fBTDS\fP\-format.
.\"}}}
.\"}}}
.\"{{{  how to get out
.NH 2
How to get out
.\"{{{  save-and-exit-origami
.LP
\fBsave-and-exit-origami\fP
.SP
Exits entered folds as needed, saves the file and exits from Origami.
.SP
.I N.B
If Origami is in view mode, the file will not be saved.
.\"}}}
.\"{{{  exit-origami
.LP
\fBexit-origami\fP
.SP
If there are unsaved changes to your file, Origami asks you if you want
to leave anyway.
.\"}}}
.\"}}}
