.\"{{{  Notes
.\" nroff -ms install.ms | more
.\"}}}
.\"{{{  header
.LP
.ps 20
.ft B
.ce 1
Installing Origami
.\"}}}
.\"{{{  Compiling Origami
.SH
Compiling Origami
.LP
Before compiling Origami, you have to generate makefiles for your
machine.  I use a shell function named mpp for this work, which
generates makefiles.  The cpp-makefiles contain explanations on how to
do this at their heads.  If you port Origami to a new machine, please
change the cpp-makefile and send me cdiffs for everything.  Origami
tries to be POSIX compatible.  Not BSD, not v7, not system V.  POSIX!  I
really hate #ifdefs in the code, which means that you should try to
write some emulations function and header files, if you want to do an
official port.  Origami doesn't run on most older systems, but it runs
unchanged on almost each POSIX compliant system.
.PP
I suggest to setup the following directory structure:
.IP \fB/usr/local/origami\fP
This directory is used for default rc files, documentation and
binding sources.
.IP \fB/usr/local/bin\fP
binaries
.IP \fB/usr/local/man/man1\fP
online manual entries
.LP
You can either tell your users to change their PATH and MANPATH
environment definitions or you can link the most important things to
/usr/bin etc.  I recommend the first way, it makes administration
easier.
.PP
Now use make install in each directory, which has a makefile.  There
is a deinstall rule to delete the installed file as well.  You will need
\fIinstall(1)\fP, it is the easiest way to install files.
.PP
I know that the places for binaries and other files of Origami have changed
each release.  I experimented with different places to find out the pros and
cons of the different possibilities.  The current solution seems to be
best.
.PP
At last, you have to make your choice, which keybindings you
personally want to use.  Read the next sections to see how to install
them.
.\"}}}
.\"{{{  The rc file
.SH
The rc file
.LP
Origami needs a rc file, which contains compiled keybindings and
macros.  Keybindings and macros are explained more detailed in the
\fBOrigami User Guide\fP.  After compiling everything, use
.DS
cd bindings
make emacs
.DE
to use an emacs-like rc file.  There are other bindings, but
they are terminal specific.  In future, there will be a vi-like binding.
Currently, there is a beta version of this.
.\"}}}
.\"{{{  Termcap
.SH
Required termcap capabilities
.LP
Origami uses the termcap database.  It requires only a few capabilities
to work and it does not need intelligent terminals.  The following
capabilities are required:
.DS
cm (cursor motion),
co (number of columns),
li (number of lines)
.DE
The following capabilities are optional and speed up the display:
.DS
ce (clear to end of line)
al (add line)
dl (delete line)
cl (clear display)
.DE
so (standout) and se (standend) are only handled, if ce is known!
Otherwise Origami acts, as if so and se are not possible on the current
terminal.
.\"}}}
