/*{{{  possible switches*/
/*
   Use the following configuration symbols to generate a makefile for
   your system with "/usr/lib/cpp -DCONFIG Makefile.cpp >Makefile"

   SUNOS_UNPROTO_CC
   SUNOS_GCC
   HPUX_UNPROTO
   HPUX_ANSI
   LINUX
   MINIX_ACKi86
   MINIX_BCCi86
   MINIX_BCCi386
   MINIX_GCCi386
   MIPS
*/
/*}}}  */
/*{{{  SUNOS*/
#if (defined(SUNOS_UNPROTO_CC) || defined(SUNOS_GCC))
DOC_PATH=        $(HOME)/origami/doc
#endif
/*}}}  */
/*{{{  HPUX*/
#if ( defined(HPUX_UNPROTO) || defined(HPUX_ANSI) )
DOC_PATH=        $(HOME)/origami/doc
#endif
/*}}}  */
/*{{{  LINUX*/
#ifdef LINUX
DOC_PATH=        /usr/local/origami/doc
#endif
/*}}}  */
/*{{{  MINIX*/
#if (defined(MINIX_ACKi86) || defined(MINIX_BCCi86) || defined(MINIX_BCCi386) || defined(MINIX_GCCi386))
DOC_PATH=        /usr/local/origami/doc
#endif
/*}}}  */
/*{{{  MIPS*/
#if defined(MIPS)
DOC_PATH=        $(HOME)/origami/doc
#endif
/*}}}  */

install:
		install -d $(DOC_PATH)
		install -m 644 *.ms *.MS $(DOC_PATH)

deinstall:
		rm -rf $(DOC_PATH)

manual.ascii:   origami.ms functions.MS ocl.MS ocl-top.MS ocl-vars.MS
		soelim origami.ms | tbl | nroff -ms >manual.ascii

manual.dvi:     origami.ms functions.MS ocl.MS  ocl-top.MS ocl-vars.MS
		soelim origami.ms | gtbl | groff -ms -Tdvi >manual.dvi

manual.ps:      origami.ms functions.MS ocl.MS  ocl-top.MS ocl-vars.MS
		soelim origami.ms | gtbl | groff -ms -Tps >manual.ps

manual.out:	origami.ms functions.MS ocl.MS  ocl-top.MS ocl-vars.MS
		mroff -ms -O origami.ms >manual.out

clean:
		rm -f manual.* *.ascii

clobber:	clean
		rm -f Makefile
