.\"{{{  Notes
.\" This manual should be improved in many points, but it is ok for a first
.\" impression of Origami.  You should have seen the original documentation,
.\" and you would be happy about this document...  On the other side, have you
.\" ever seen the GNU Emacs manual?  It is for people who are able to read the
.\" whole bible while waiting for the bus.
.\" I wrote this manual using Origami and the -ms macros of MROFF, but it
.\" is also usable with gtbl/groff and the SunOS nroff.
.\"
.\" Michael Haardt
.\"}}}
.\"{{{  A few roff definitions
.\" Although I hate macros in documents, there does not seem
.\" to be another way for this manual.  I hope that this macro
.\" will work with every existing roff and -ms package.
.\"
.\" small paragraph
.de SP
.nr PD .15v
.IP "" .75c
.nr PD .75v
..
.\" my favourite university machine and my official home in netland :)
.ds ac @messua.informatik.rwth-aachen.de
.ds Tx T\v'2p'E\v'-2p'X
.\"}}}
.\"{{{  Title and abstract
.ds CF 1st April 1992
.TL
Origami User Guide
.AU
Michael Haardt
u31b3hs\*(ac
.AI
.\" Grrrr -- I will use something better next time, who knew that groff knows \(oe
.if "\(oe"" Auf der Hoern 40
.if !"\(oe"" Auf der H\(oern 40
5100 Aachen
Germany
.AB
This document describes all basic functions of Origami.  It never refers
to specific keys, because the Emacs-like and the TDS keybindings are
completely different.  It also explains the OCL macro language.
.AE
.\"}}}
.\"{{{  Using Origami
.NH 1
Using Origami
.\"{{{  Getting started
.NH 2
Getting Started
.LP
You have the choice either to read the next chapters about using Origami
or to use the tutorial to learn by doing.  This tutorial is similar to
the well known teach-emacs tutorial.  You need a copy of the learn
directory.  Change to this directory and type:
.DS
\fBstart-me\fP
.DE
This tutorial must be used in Emacs-mode.
.PP
It is assumed that Origami is installed and ready to use on your system.
It is invoked by typing \fBorigami\fP at the system prompt.  Filenames
may be typed after \fBorigami\fP \(em if this is not done a prompt for a
filename will be issued.
.\"{{{  ctrl-char
.PP
Control characters will be displayed as \fB^\fP followed by the ASCII
coding of the control character (\fB@A\fP..\fBZ[\e]^_\fP for characters
0..31).  The null character cannot be handled properly for internal
reasons.  Everything following the null character will be ignored.
newline will cause a line break.  It cannot be used as input.  Use
newline-and-indent instead.
.\"}}}
.\"{{{  tabs + spaces
The tab character can be handled in different ways (default is
\fB\-t8\fP), depending on the choosen command line option:
.ne 3
.LP
\fB\-t\-1\fP:
.SP
Handle tabs as normal control character and display it with a inverted
\fBI\fP.  Tabs in the keyboard input will be handled as normal control
character.
.ne 3
.LP
\fB\-t0\fP or \fB\-t\fP:
.SP
Origami will ask for the tab size in order to preserve your formatting.
All tab characters will be converted into the corresponding number of
spaces, and the file will contain these spaces instead of tabs when it
is written back.  Tabs in the keyboard input will be ignored.
.ne 3
.LP
\fB\-t\fP\fIn\fP, \fIn\fP>0:
.SP
All tabs remain in the text and are handled in the right way.  Tabs
in the keyboard input will be handled like as such.  Tabs are not allowed
in front of fold lines or before indentation of current fold.
.LP
Spaces and tabs at end of line will be deleted when writing the file.
.\"}}}
.LP
If you don't have write permission for the specified file, Origami will
enter view only mode.  Look at the manual page for advanced command
line options.
.\"}}}
.\"{{{  The screen format
.NH 2
The Screen Format
.LP
On starting an Origami session, a status line appears near the bottom of
the screen.  This line will remain throughout your edit session and any prompts
or warnings issued by the editor will appear below this line.  If you
started typing a key sequence bound to a command, this sequence will be
displayed under the status line, as well.  If the second character of the
line is a star, your file contains unsaved changes.  The current
language and the active modes are indicated in parentheses:
.\"{{{  table of modes
.ne 6
.TS
tab(|);
l l l.
long|short|meaning
\fBFolding\fP|\fBF\fP|displayed while a fold is being created.
\fBDefMac\fP|\fBD\fP|defining a keyboard macro
\fBView\fP|\fBV\fP|Origami is in view only mode.
\fBOver\fP|\fBO\fP|Origami is in overwrite mode.
\fBAutoSave\fP|\fBS\fP|Origami is in auto save mode.
.TE
.\"}}}
.LP
The short forms are used if the statusline is too long.  If there is a
name defined in your keybinding file, it is displayed to the left of the
version number instead of `\fBOrigami\fP'.  If the filename is too long to be
shown in the statusline, Origami tries to cut the path and displays
`\fB...\fP' instead of the omitted part of the path.
.\"}}}
.\"{{{  The editor buffers
.NH 2
The Editor Buffers
.LP
There are three buffers in Origami.  The `move buffer' contains up to
one text line, the `kill buffer' in which several lines can be collected
before inserting them back into the file, and the `delete buffer', which
holds the last deleted line (in each case a line can be a closed fold,
with all its contents).  The operations of these buffers in Origami are
slightly different from TDS (INMOS Transputer Development System) \(em
move, delete and kill buffers are lost on exit from Origami.
.\"}}}
.\"{{{  Processing Origami files
.NH 2
Processing Origami Files
.LP
If a saved file is to pass though a particular compiler, the fold
structure must be hidden from the compiler by writing it as comments.
Origami hides the fold-markers by adding up to 3 characters to the start
and end of the fold-marker.  As comments differ from one language to
another, it is necessary to choose the language before saving a new file
for the first time.  When reading a file back into Origami the language
type is retained (provided that the file contained at least one fold).
As a consequence you should take care not to include compiler comments
within the fold header, as this will lead to nested comments which are
not allowed in some languages.
.PP
The general technique for hiding a fold is:
.\"{{{  example
.DS
\&{\&{\&{  this is a fold
\&.\&.\&.F  this is a filed fold for file xyz.a
\&}\&}\&}
.DE
appears as
.DS
/*\&{\&{\&{  this is a fold*/
  /*\&{\&{\&{F this is a filed fold*/
  /*\&:\&:\&:F xyz.a*/
  /*\&}\&}\&}  */
/*\&}\&}\&}  */
.DE
in the text file (language C).
.\"}}}
.PP
Origami knows the following languages, to hide fold-markers:
.\"{{{  table of values for comments
.ne 12
.TS
tab(|);
l l s
l l l
l l l
l l l
l l l
l l l
l l l
l l l
l l l
l l l
l l s
l l s.
Language|foldline comments:
|start|end
None||
Occam|\-\-|
Pascal|(*|*)
C|/*|*/
Lisp|;|
Roff|\&.\e"|
\*(Tx|%|
Script|#|
User|any sequences, up to 3 characters long|
Inmos|a binary format, see below
.TE
.\"}}}
.\"}}}
.\"{{{  Inmos files
.NH 2
Inmos Files
.LP
Inmos files can be edited without losing information.  There are some
restrictions on editing Inmos files:
.LP
Filed folds:
.IP \(bu
Origami cannot open filed folds, only entering is possible.
.IP \(bu
Origami doesn't automatically remove files belonging to deleted filed
folds and doesn't generate unique filenames on filing folds.
.LP
\fBEXE\fP, \fBLIB\fP, .. :
.IP \(bu
Origami isn't able to create special fold-types automatically, but can
handle existing ones properly.  You can use a OCL-command to set
fold-type and fold-contents within a macro to integer values.
.LP
Inmos and ASCII-files:
.IP \(bu
Since version 1.6.31, the ASCII-format (using fold-languages \fBNONE\fP,
\fBC\fP, .. ) for Inmos files has changed.  The differences concern only
the additional fold attributes (like \fBEXE\fP, \fBSC\fP, .. ).  The new
format should be able to save Inmos files with another language without
losing of information, but we cannot guarantee this feature!  Check this
in your environment, before using it widely.
.IP \(bu
Changing the language from Inmos to another one and writing the file
does only change the current file. Included filed-folds won't be changed
by this!
.\"}}}
.\"}}}
.\"{{{  All Origami functions
.\"{{{F functions.MS
.\":::F functions.MS
.\"}}}
.so functions.MS
.\"}}}
.\"{{{  Programming in OCL
.NH 1
Programming in OCL
.\"{{{  introduction to this chapter
.LP
This chapter describes OCL (Origami control language) and gives some
examples to show how powerful it is.  OCL is a programming language
offering capabilities to use conditional statements, subroutines, loops,
variables and recursion.  It looks like LISP, but it is closer to an
assembly language.  The keybind program compiles human readable OCL
source code into a tokenized binary form which will be interpreted by
Origami.  Every binding of functions to keyseuences must be done in this
binary file.  The functions described in the chapter explaining
keybindings are very simple OCL statements.
.\"}}}
.\"{{{  OCL syntax and semantic
.\"{{{F ocl.MS
.\":::F ocl.MS
.\"}}}
.so ocl.MS
.\"}}}
.\"{{{  OCL examples
.NH 2
OCL examples
.LP
This section includes some commented OCL examples for you to browse through
before starting your own applications.
It is assumed that you are familiar with Origami before you
start programming in OCL.
.\"{{{  simple keybindings
.NH 3
Bindings keys
.LP
The following examples show how you can bind commands to (sequences of)
keys and how aliases work.
.\"{{{  first example with return
.DS
; This is a simple keybind file
(keybind newline-and-indent C-M)
.DE
The operation `newline-and-indent' is activated by pressing the key C-M.  The
line `newline-and-indent C-M' will be included in the keybinding help screens
available to the user.
.\"}}}
.\"{{{  same example with alias
You can achieve the same keybinding by using an alias:
.DS
; This keybinding uses alias
(alias enter C-M)
(keybind newline-and-indent $enter)
.DE
The operation `newline-and-indent' is activated by C-M as before;
the keybinding help will show `newline-and-indent enter'.  If your
terminal would send an unusual sequence of characters for the enter key instead
of the C-M character (very rare), you would just define your own alias for $enter
and leave the comprehensive keybind command unchanged.
.\"}}}
.\"}}}
.\"{{{  byebye
.NH 3
A small function
.LP
The first OCL example does not use any control structures.  It defines a
macro named byebye.  You should play a little with such macros
to get used to the compilation process and its (error) messages.
.DS
; this is an example for a macro definition:
(deffun byebye
(
  end-of-fold
  beginning-of-line
  newline-and-indent
  previous-line
  "end "  "of " "text
))
.sp
(keybind byebye (M-"x "bye))
.DE
byebye creates a new line containing \fBend of text\fP at the end of the
entered fold.
.\"}}}
.\"{{{  shell version control
.NH 3
Shell version control
.LP
Two more little macros deal with SVC.  Note that the check out macro is
only for personal use of SVC.  If you are working in a group, someone
else may have edited the file, which will not change your own read only
copy.  The advantage is that you can visit a file and decide if you want
to change it.
.DS
(deffun check-out (
  delete-mode-view
  shell-command "co "  "-l "  "$ORIFILE
))

(deffun check-in (
  save-file
  add-mode-view
  shell-command "ci "  "-u "  "$ORIFILE
))
.DE
.\"}}}
.\"{{{  mtool-top
.NH 3
MTool-version of top-of-fold
.LP
This a macro version of the command top-of-fold as it is used in the
mtool system.  The cursor moves to the begin of the currently opened
fold.
.DS
; example for a more complex macro
(deffun mtool-top
(
  if test-end-fold (previous-line) fi
  while and(not(test-begin-fold),not(test-top))
  (
    if test-end-fold (mtool-top) fi
    previous-line
  )
))
.DE
While the cursor is not being located on top of a fold (entered or
opened) the cursor is moved up. If the macro finds the end of fold line
from another opened fold, this fold is skipped by a recursive call of
mtool-top.
.\"}}}
.\"{{{  fill-paragraph
.NH 3
Fill paragraph
.LP
The next example macro is a bit more advanced.  It is too lengthy to include
it here, but it can be found in the file fill-paragraph.
.PP
fill-paragraph fills all lines from cursor position to the next line
with a blank (or a dot in ``roff-mode'') in the first column.  An end of
a fold stops filling too.  The first column of a line is here the first
character in currently entered fold, not opened fold!  Filling a line
means to add words from the next line if it is too short or to put words
to the next line if it is too long.  The default right margin is set to
column 72.  If there are unfillable lines, fill-paragraph stops filling
and complains.  Fill-column counts from beginning of entered fold
indentation.
.PP
The filling can be done in the following 3 ways:
.IP "roff-mode (switched on when Origami starts)" .75c
All ``. '' are expanded to ``.  ''.
.IP "block-mode" .75c
All `` '' are expanded to ``  '', till the line reaches the fill margin.
.IP "shrink-mode" .75c
All ``  '' are replaced by `` '' and the right margin remains unaligned or ragged.
.LP
The macro inv-blank-handle switches between these modes.
.PP
The macro auto-wrap can be used instead of `` ''.  If the cursor is at
end of line, the currently typed word is automatically wrapped into a new line.
.PP
The macro set-fill-column allows to change the right margin.  To do so,
you can either use a numeric argument, point to the position of the new right
margin with the cursor or make Origami prompt for the new column width by moving
the cursor to the left margin.
.\"}}}
.\"{{{  goto-matching-fence
.NH 3
Goto matching fence
.LP
If you are writing programs, you often want to know which parentheses
match in a complicated expression.
goto-matching-fence performs this function.  It uses the character
under the cursor to determine if you are looking for a round, square or curly bracket
and if you want to jump to the opening or the closing one.  If the
cursor is not located on a bracket, nothing will happen.  Otherwise
the macro searches the matching fence.  If it can't find it, it will
move back to your old position.  If necessary, this macro opens and
closes folds.  Do not worry if it does not seem to stop searching.  If
your text is very long and there is no fitting fence, you will be
amazed how many folds you are using and how fast they can be opened and
closed, but usually goto-matching-fence will exit gracefully at last. Remember
the operation can also be interrupted by the abort character (often bound to C-C).
.\"}}}
.\"{{{  towers-of-hanoi
.NH 3
The towers of hanoi
.LP
This is a funny macro to demonstrate the power of OCL.  You should type a
string of a few characters without blanks, then start this macro and
have fun.  Warning: If you type more than about eight to ten characters, the
game will require a long time.
.\"}}}
.\"{{{  conditional compilation
.NH 3
Conditional compilation
.\"{{{  simple example
.LP
A simple example for the usage of conditional compilation:
.DS
@if-using (foo)
  .\&.\&.  block
@fi
.DE
\fB.\&.\&.  block\fP will only be compiled if the tag \fIfoo\fP is known
as used.  This can be done by an earlier \fB@use (\fP\fIfoo\fP\fB)\fP or
by the commandline option \fB-U\fP\fIfoo\fP.
.\"}}}
.\"{{{  file-fold example
.LP
Another example shows the usage of conditional compilation to prevent
multiple compilation of a file:
.DS
@if-using not(FILENAME)
  @use (FILENAME)
  \&.\&.\&.  block
@fi
.DE
.LP
This technique is used in the library files in the bindings directory.
.\"}}}
.\"{{{  multiple configurations
.PP
The following example shows, how different keyboards, macro sets etc.\&
can be handled properly with one OCL source.  You need only one tag to
choose the correct environment.  This can be done either by an earlier
\fB@use (\fP\fI??\fP\fB)\fP or by the command switch \fB\-U\fP\fI??\fP.
.DS
.\"{{{  set tags
{\&{\&{  choose corect compilation tags
@if-using (kbd_1_macros_1)
  @use ( kbd_1 mac_1 )
@fi
@if-using (kbd_2_macros_1)
  @use ( kbd_2 mac_1 )
@fi
; you can write such statements as well:
@if-using (kbd_1_macros_2) @use ( kbd_1 mac_2 ) @fi
@if-using (kbd_2_macros_2) @use ( kbd_2 mac_2 ) @fi
@if-using ( kbd_2_c ) @use (kbd_2 c_macs mac_1) @fi
}\&}\&}
.\"}}}
.DE
.DS
.\"{{{  macros
{\&{\&{  macros
\&.\&.\&.  simple macros
@if-using (mac_2)
  .\&.\&.F special tex macros
@fi
@if-using (mac_1)
  .\&.\&.F text edit helps
@fi
@if-using (c_macs)
  .\&.\&.F c_macros
@fi
}\&}\&}
.\"}}}
.DE
.DS
.\"{{{  kbd
\&{\&{\&{  keyboard mapping
\&.\&.\&.  terminal_keymap (esc,shift,ctrl ... )
@if-using (kbd_1)
  .\&.\&.F simple_keys (cursor- and functionkeys)
@fi
@if-using (kbd_2)
  .\&.\&.F more_complex_keys (cursor- and functionkeys)
@fi
}\&}\&}
.\"}}}
.DE
The usage of more descriptive identifiers is left as an exercise for
the reader.
.\"}}}
.\"}}}
.\"{{{  terminals und modes
.NH 3
Modes and terminals
.\"{{{  simple example
.LP
A simple example for the usage of multiple keyboards is the following:
.\"{{{  example
.DS
(defmodes edit shell)
.DE
.DS
( deffun shell-commands ( add-mode-view shell ) )
( deffun editing ( delete-mode-view edit ) )
( abort-macro editing )
.DE
.DS
(mode edit
  .\&.\&.  bind all normal edit commands
  ( keybind shell-commands ( .. ) )
)
.DE
.DS
(mode shell
  .\&.\&.  bind commands calling special shell scripts
  ( keybind editing       ( .. ) )
)
.DE
.DS
\&.\&.\&.  some other macros
(mode shell    ; mode is splitted in 2 definitions
  .\&.\&.  bind commands calling special shell-scripts,part 2
)
.DE
.\"}}}
This enables you to use all normal characters for your
shell commands or predefined system calls.
.\"}}}
.\"{{{  terminals
.PP
Another example shows the usage of terminal dependent bindings.
.\"{{{  example
.DS
(defmodes keyboard)
\&.\&.\&.  aliases for SUN-keyboard
\&.\&.\&.  aliases for PC-keyboard
(mode keyboard
  .\&.\&.  all normal edit commands
  ( terminal SUN
     .\&.\&.  all SUN keyboard function keys
  )
  ( terminal PC
     .\&.\&.  all PC keyboard function keys
  )
)
.DE
.\"}}}
.LP
Origami loads only one of the given tables, depending on the value of $ORITERM
or $TERM.  The default keyboard uses none of the additional bindings.
.PP
The following is an example for using terminal dependencies for aliases too:
.\"{{{  example
.DS
(defmodes keyboard)
.DE
.DS
\&{\&{\&{  aliases for SUN keyboard - autoalias
; created with 'autoalias -tsun'
( terminal sun
   ( alias up ( ... ) )
   \&.\&..
)
\&}\&}\&}
\&.\&.\&.  aliases for PC keyboard  - hand coded
.DE
.DS
(mode keyboard
  .\&.\&.  all normal edit commands
  ( terminal ( sun PC )
     ( keybind previous-line ( $up ) )
       ; instead of $up, $sun@up and $PC@up
       ; will be used in the two tables
     \&.\&..
  )
)
.DE
.\"}}}
.\"}}}
.\"}}}
.LP
These examples should give an impression of what can be done using OCL.
There are more macros stored in the bindings directory.  I am sure that
you will invent more useful OCL macros.  If you wrote a really new and
good one, please post it to the USENET newsgroup comp.editors.
.\"}}}
.\"}}}
.\"{{{  Mouse extension
.NH 1
Mouse extension
.LP
On some systems, Origami can be used with a mouse.  The rc-file format
is independent from mouse-support.  If Origami isn't able to support the
mouse, the corresponding information in the rc-file is ignored!
.\"{{{  available mouse-supports
.NH 2
Available implementations
.LP
Origami can be used with a mouse in the following window environments:
.\"{{{  X
.IP X 1i
Defining the symbol \fBXTERM\fP at compile time enables the mouse support
for X.  Running \fBOrigami\fP inside a \fBxterm\fP will activate
\fIsend mouse position on click\fP via sending '\\033[?9h' to the terminal
and resetting afterwards.  You can use up to 10 mouse buttons.  They are
named \fBButton1\fP .. \fBButton10\fP in the bindinglist.  The mouse will only
be activated, if the environment variable \fBTERM\fP is set to
\fBxterm\fP.  Pressing the mouse will activate the Origami actions.
.br
\fBCut\fP/\fBPaste\fP function can be reached (on a standard xterm) via
shift mouse button.  See in your xterm- and X manuals for more details
about mapping the mouse keys.  Use \fBORITERM\fP to control the loading
of different keytables for different terminals!
.br
If Origami is used in a xterm, you can use the command line option
\fB\-T\fP \fItitle\fP to change the window title to the current
filename.  After exiting Origami, the title is set to \fItitle\fP.  If
\fItitle\fP is the empty string, \fBxterm\fP is used.
.\"}}}
.\"{{{  MGR
.IP MGR 1i
Defining the Symbol \fBMGR\fP at compiletime enables the mouse support
for the Bellcore window manager MGR.  Running \fBOrigami\fP will
activate \fIsend mouse position on click\fP with \fBm_setevent\fP and
resetting afterwards.  You can use 5 mouse buttons, pressing and
releasing the button are distinguished.  The buttons are named
\fBButton1\fP..\fBButton5\fP, \fBButton1Down\fP..\fBButton5Down\fP in
the bindinglist (\fBButton3\fP..\fBButton5\fP are not supported yet).
The mouse will only be activated, if the environment variable \fBTERM\fP
is set to \fBmgr\fP.  See in your local mgr manuals for more information
about mouse mapping.  Use \fBORITERM\fP to control the loading of
different keytables for different terminals!
.\"}}}
.\"{{{  MGR + X
.IP "X and MGR together" 1i
MGR and X support can be used together, because the MGR mouse support
uses the escape sequence from the X mouse support to detect a mouse
click.
.br
Enable both supports by defining XTERM and MGR.
.br
The commandline option \fB\-T\fP works only, if Origami is used in a
xterm.
.\"}}}
.LP
Different mouse-supports in Origami and keybind (rc-file) can be used
together, if
.IP \(bu
both use the same `escape sequence' to mark a mouse-click,
.IP \(bu
or Origami scanns the mouse itself.
.LP
In these cases, the mapping of mouse buttons is defined by Origami.
Otherwise the mouse won't work.
.\"}}}
.\"{{{  Using the mouse in OCL
.NH 2
Using the mouse in OCL
.LP
All keytables, not named like a mouse-support use the default
mouse-support (\fBxterm\fP).  This can be changed with \fB\-M
\fP\fIxxx\fP.  If the mouse-support is not set to \fBno-mouse\fP, the
OCL-tags \fBMOUSY\fP and \fIxxx\fP are set and the mouse-variables are
defined.  Otherwise, only the buttons are mapped to commands, but the
mouse-variables are not used and no \fBMOUSY\fP is set!  The mouse can be
used with
.LP
\fB(mouse-buttons\fP \fICOMMAND-FOR-1 COMMAND-FOR-2\fP .. \fB)\fP
.SP
Pressing the mouse button \fIx\fP (number \fIx\fP in the above mentioned
namelists) will activate \fICOMMAND-FOR-x\fP, which can be any Origami
command or OCL macro.  If one of the buttons should not be used, bind
\fBno-operation\fP to it.  Only the button numbers are stored in the
rc-file.  The names are generated by Origami at runtime, depending on
Origami and its runtime environment.
.LP
If the choosen mouse-support is not \fBno-mouse\fP, the following OCL
variables are defined automatically and set on mouse click before
running the command:
.ne 12
.TS
tab(|);
l l s
l l s
l l s
l l l
l l s
l l l
l l s
l l l
l l l
l l s
l l l
l l l.
variable:|used for:
\fBmouse-b\fP|number of pressed button
\fBmouse-x\fP|column number the mouse pointed to
||useful for: \fBgoto-counter\fP
\fBmouse-y\fP|line number of mouse position
||useful for: \fBgoto-line\fP
\fBmouse-go-y\fP|number of steps down
||useful for: \fBnext-line\fP
||negative values: \fBprevious-line\fP
\fBmouse-outside\fP|clicked inside the text?
||\-1 if pressed outside the text
||0 otherwise
.TE
.\"}}}
.\"}}}
.\"{{{  Miscellanous
.NH 1
Miscellanous
.LP
If a document is to be loaded for the first time you should verify that
it doesn't contain strings which could be misinterpreted as fold marks
by Origami.  The following simple shell script looks for such strings.
.DS
fgrep '{\&{\&{' <filename>
fgrep '}\&}\&}' <filename>
fgrep ':\&:\&:' <filename>
.DE
.\"}}}
.\"{{{  Copyrights
.NH 1
Copyright appointments
.LP
This chapter wasn't included in earlier versions, but a discussion on
USENET convinced me to write it.  Please read it carefully.
.PP
Each part of this software can and must be copied free.  If you copy
binaries, you must not prevent people from copying sources, too.  You
must not remove my name from this program.  If you want to use parts of
it for your own purposes, point out what is your code and what is mine.
You use this software completely on your own risk.
.PP
No part of this software may be used for military purposes.  I will make
no exceptions for this point.
.PP
If someone wants to use software or parts of it from this package for
commercial purposes, he needs a written non exclusive license.
.PP
There are no remarks in the other files of this package about copyright
and these things, because program code and comments about it are two
different things, but the above conditions are valid for the whole
package!
.\"}}}
.\"{{{  Acknowledgements
.NH 1
Acknowledgements
.LP
Most of this manual was written by me, but the original was written by
someone else, who didn't leave his name in it.  The concept of the
folding editor was originally implemented as part of the Transputer
development system at INMOS Ltd., Bristol, UK.  The editor was a part of
the TDS D700, and was written in Occam.  It first ran on a 68000 based
Sage/Stride development system, and later was Transputer resident on the
PC development system.
.PP
Origami was rewritten from scratch in Turbo Pascal by Martin Green while
at Ferranti Ltd, Cheadle Heath, Stockport, England, and used the same
key mappings and editor functions as the TDS editor.
.PP
It was then converted from Turbo Pascal by p2c and ported by Charlie
Lawrence, while at Eastman Kodak Co.  He added lex/yacc based keyfiles,
and did the considerable work needed to get it running in C.
.PP
I fixed some bugs in memory managment and otherwhere, ported it to
MINIX, changed its user interface to look more Emacs-like and added new
features.  Wolfgang Stumvoll (stumvoll\*(ac) wrote the OCL code and the
keybind compiler.  He also made beta tests of all my new versions by
using them for his daily work, which helped a lot to find existing and
new bugs.  Last but not least, he wrote the OCL fill-paragraph,
goto-matching-fence and towers-of-hanoi macros.  Both of us made a
general code clean up, which was highly overdue.
.PP
Michael Schwingen (michaels\*(ac) ported Origami to Atari TOS and fixed
a few minor bugs.
.PP
Robert Blum (blum\*(ac) ported Origami to MS/PC DOS.
.PP
Andrew Miller (windy\*(ac) spent much time proofreading the
documentation and is still writing the vi Emulation.  He tested most new
versions on his MINIX machine as well.
.PP
There are too many people in different nets all around the world, who helped
with small tips, bugreports etc.\& to improve Origami.  Thanks to all
of you.
.PP
I maintain the whole Origami source code, which means that I will answer
or forward mail concerning Origami, decide if and how extensions should
be made, give advices for people who are porting it, post new UN*X
versions and update the documentation.
.\"}}}
