/*{{{  possible switches*/
/*
   Use the following configuration symbols to generate a makefile for
   your system with "/usr/lib/cpp -DCONFIG Makefile.cpp >Makefile"

   SUNOS_UNPROTO_CC
   SUNOS_GCC
   HPUX_UNPROTO
   HPUX_ANSI
   LINUX
   MINIX_ACKi86
   MINIX_BCCi86
   MINIX_BCCi386
   MINIX_GCCi386
   MIPS
*/
/*}}}  */
/*{{{  SUNOS*/
#if (defined(SUNOS_UNPROTO_CC) || defined(SUNOS_GCC))
MAN_DIR=        $(HOME)/man
MAN_EXT=
#endif
/*}}}  */
/*{{{  HPUX*/
#if ( defined(HPUX_UNPROTO) || defined(HPUX_ANSI) )
MAN_DIR=        $(HOME)/man
MAN_EXT=
#endif
/*}}}  */
/*{{{  MINIX*/
#if (defined(MINIX_ACKi86) || defined(MINIX_BCCi86) || defined(MINIX_BCCi386) || defined(MINIX_GCCi386))
MAN_DIR=        /usr/local/man
MAN_EXT=
#endif
/*}}}  */
/*{{{  LINUX*/
#ifdef LINUX
MAN_DIR=        /usr/local/man
MAN_EXT=
#endif
/*}}}  */
/*{{{  MIPS*/
#if defined(MIPS)
MAN_DIR=        $(HOME)/man
MAN_EXT=
#endif
/*}}}  */

install:
		install -d $(MAN_DIR)
		install -m 644 autoalias.1 $(MAN_DIR)/man1/autoalias.1$(MAN_EXT)
		install -m 644 dirfold.1 $(MAN_DIR)/man1/dirfold.1$(MAN_EXT)
		install -m 644 keybind.1 $(MAN_DIR)/man1/keybind.1$(MAN_EXT)
		install -m 644 origami.1 $(MAN_DIR)/man1/origami.1$(MAN_EXT)
		install -m 644 oripager.1 $(MAN_DIR)/man1/oripager.1$(MAN_EXT)
		install -m 644 viewrc.1 $(MAN_DIR)/man1/viewrc.1$(MAN_EXT)

deinstall:
		rm -f $(MAN_DIR)/man1/autoalias.*
		rm -f $(MAN_DIR)/man1/dirfold.*
		rm -f $(MAN_DIR)/man1/keybind.*
		rm -f $(MAN_DIR)/man1/origami.*
		rm -f $(MAN_DIR)/man1/oripager.*
		rm -f $(MAN_DIR)/man1/viewrc.*

clobber:
		rm -f Makefile
