/* This file is part of the origami distrubution. (Amiga Port)
 *
 * Source code written by Thomas Hadig in January 1992
 * Version : 1.6.39 gamma, April 1992
 * Arexx Version : gamma
 * (C) 1992 by Thomas Hadig
 * may be distributed unchanged ! (see copyright notes)
 *
 * This is a special task, that will be loaded, when an Arexx is wanted
 * !!! This version is experimental !!!
 * Please read the file   readme.rexx  for more information
 *
 * A great help to write this was the Simple ARexx interface by Michael Sinz
 * Thanks
 */
/*{{{  Origami Port Schema*/
#if 0
Origami                       OriArexx                          Arexx
           b,c1,d1,e                                    e
unnamed      1-->--------#---------------#--------->----------3 Port RXSDIR
(from Origami)           |               |                      (to Arexx)
                         Y               ^
                         |b,c1,d1        |
                       +++++++++++++++++++++
                       +      OriArexx     +
                       +++++++++++++++++++++
                         |a,c2,d2        |
                         |               |
                         Y               ^
Port Oxxxxxx 2--<--------#---------------#---------<----------4 Port ORIGAMIxxxxxx
(to Origami)  a,c2,d2                                           (from Arexx)

Message Types :
   |  Port |                |
No.|from|to| Description    | Arguments
a  | -  | 2| AREXX_CAME_UP  | in ReplyPort : Port Addres : 1 (*)
b  | 1  | -| AREXX_COME_DOWN| none
   |    |  |                |
c 1| 1  | -| AREXX_OUT      | "$PORTNAME",
  2| -  | 2| reply          | will send message("ORIGAMIxxxxx")
d 1| 1  | -| AREXX_OUT      | "$QUIT",
  2| -  | 2| reply          | will quit
e  | 1  | 3| AREXX_OUT      | name, (<>$PORTNAME,$QUIT) will start script name


#endif
/*}}}  */
/* in the moment : a,b,c1,d1,e*/
/*{{{  comments*/
#if 0
GetARexxMsg (level 0) : gets one Arexx Message, if present
GetOneMsg (level 1) : gets one Message from Origami or Arexx (GetARexxMsg)
GetOneMsg_HandleOPort (level 1) : gets one Message and handles it, if it
                                  is an Origami Port Message
main : handle all messages
#endif
/*}}}  */

/*{{{  includes*/
/*{{{  standards*/
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
/*}}}  */
/*{{{  exec stuff*/
#include <exec/types.h>
#include <exec/nodes.h>
#include <exec/lists.h>
#include <exec/ports.h>
#include <exec/memory.h>
/*}}}  */
/*{{{  rexx stuff*/
#include <rexx/storage.h>
#include <rexx/rxslib.h>
/*}}}  */

#include <proto/exec.h>

#define ORI_AREXX_C
#define I_REXXSCAN_C

#include <local/bool.h>
#include <keybind.h>
#include "origami:amiga/h/arexx.h"
/*}}}  */
/*{{{  variables*/
extern int input;
int quit = 0;
FILE *fd=NULL;
bool get_new_string = FALSE;

struct My_ArexxMessage *msg1,*msg2,msg;
/*{{{  OrigamiARexx*/
struct OrigamiARexx OrigamiARexx =
{
  NULL, NULL, NULL, "ORIGAMI","ORIGAMI.LASTERROR","ORI",
  NULL, "O",  NULL, NULL,
  0, 0, NULL, NULL, 0, 0
};
/*}}}  */
/*}}}  */

/*{{{  debugs*/
#ifdef DEBUG
#define MAX_LEVEL 50
char fun_names[MAX_LEVEL][20],debug_str[50];
int debug_lev=0;

/*{{{  DEBUG_NEWFUN*/
void DEBUG_NEWFUN (char *name)
{
  if (debug_lev==MAX_LEVEL-1)
  {
    fprintf (fd,"Please increase MAX_LEVEL !!!!!!!!\n>");
  }
  else
  {
    strcpy (fun_names[debug_lev++],name);
    fprintf (fd,"Entered Function : %s, Debug Level : %d\n>",name,debug_lev);
  }
  fgets (debug_str,50,fd);
}
/*}}}  */
/*{{{  DEBUG_ENDFUN*/
void DEBUG_ENDFUN (void)
{
  fprintf (fd,"Left Function : %s, Debug Level : %d\n",
    fun_names[--debug_lev],debug_lev+1);
  fprintf (fd,"Now in Function : %s\n>",fun_names[debug_lev-1]);
  fgets (debug_str,50,fd);
}
/*}}}  */
/*{{{  DEBUG_FUN*/
void DEBUG_FUN(char *out)
{
  if (out) fprintf (fd,"%s>",out);
  else fprintf (fd,">");
  fgets (debug_str,50,fd);
}
/*}}}  */
#else
/*{{{  NO DEBUG*/
#  define DEBUG_NEWFUN(a)
#  define DEBUG_ENDFUN()
#  define DEBUG_FUN(a)
/*}}}  */
#endif
/*}}}  */

/*{{{  Level 0*/
/*{{{  GetARexxMsg*/
struct RexxMsg *GetARexxMsg(void)
{
  struct  RexxMsg *tmp=NULL;
  short flag;

  DEBUG_NEWFUN ("GARM");
  if (tmp=(struct RexxMsg *)GetMsg(OrigamiARexx.ARexxPort))
  /*{{{  handle message*/
  {
    DEBUG_FUN ("Got Message !");
    /*{{{  only reply*/
    if (tmp->rm_Node.mn_Node.ln_Type==NT_REPLYMSG)
    {
      flag=FALSE;
      if (tmp->rm_Result1) flag=TRUE;
      DeleteArgstring(tmp->rm_Args[0]);
      DeleteRexxMsg(tmp);
      OrigamiARexx.Outstanding-=1;
      tmp=flag ? REXX_RETURN_ERROR : NULL;
    }
    /*}}}  */
  }
  /*}}}  */
  DEBUG_ENDFUN ();
  return(tmp);
}
/*}}}  */
/*{{{  ReplyARexxMsg*/
void ReplyARexxMsg(struct RexxMsg *rmsg, char *RString,LONG Error)
{
  if ((rmsg)&&(rmsg!=REXX_RETURN_ERROR))
  {
    rmsg->rm_Result2=0;
    if (!(rmsg->rm_Result1=Error))
    {
      /*{{{  no error : return RString*/
      if (rmsg->rm_Action & (1L << RXFB_RESULT)) if (RString)
      {
        rmsg->rm_Result2=(LONG)
          CreateArgstring(RString,(LONG)strlen(RString));
      }
      /*}}}  */
    }
    ReplyMsg((struct Message *)rmsg);
  }
}
/*}}}  */
/*{{{  SetARexxLastError*/
short SetARexxLastError(struct RexxMsg *rmsg, char *ErrorStr)
{
  short OkFlag=FALSE;

  if (rmsg) if (CheckRexxMsg(rmsg))
  {
    if (!SetRexxVar(rmsg,OrigamiARexx.ErrorName,ErrorStr,(long)strlen(ErrorStr)))
    {
      OkFlag=TRUE;
    }
  }
  return(OkFlag);
}
/*}}}  */
/*{{{  SendARexxMsg*/
short SendARexxMsg(char *RString, short StringFile)
{
  struct  MsgPort *RexxPort;
  struct  RexxMsg *rmsg;
  short flag=FALSE;

  if (RString)
  {
    if (rmsg=CreateRexxMsg ( OrigamiARexx.ARexxPort,OrigamiARexx.Extension,
                             OrigamiARexx.ARexxPortName))
    {
      /*{{{  Could create rexx msg*/
      rmsg->rm_Action=RXCOMM | (StringFile ? (1L << RXFB_STRING) : 0);
      if (rmsg->rm_Args[0]=CreateArgstring(RString,(LONG)strlen(RString)))
      {
        /*{{{  look for port and send*/
        Forbid();
        if (RexxPort=FindPort(RXSDIR))
        {
          /*{{{  send msg*/
          PutMsg(RexxPort,(struct Message *)rmsg);
          OrigamiARexx.Outstanding+=1;
          flag=TRUE;
          /*}}}  */
        }
        else
        {
          /*{{{  couldn't send*/
          DeleteArgstring(rmsg->rm_Args[0]);
          DeleteRexxMsg(rmsg);
          /*}}}  */
        }
        Permit();
        /*}}}  */
      }
      else DeleteRexxMsg(rmsg);
      /*}}}  */
    }
  }
  return(flag);
}
/*}}}  */
/*}}}  */
/*{{{  Level 1*/
/*{{{  Send Messages*/
/*{{{  send message*/
void send_origami (struct My_ArexxMessage *msg)
{

}
/*}}}  */
/*{{{  print_ori_message*/
void print_ori_message (char *text)
{
  fprintf (fd,"Origami:%s\n",text);
}
/*}}}  */
/*{{{  print_rexx_message*/
void print_rexx_message (char *text)
{
  fprintf (fd,"AREXX:%s\n",text);
}
/*}}}  */
/*}}}  */
/*{{{  Get Messages*/
/*{{{  GetOneMsg*/
private int GetOneMsg (struct My_ArexxMesssage **m)
{
  int rexx_q = 0;

  DEBUG_NEWFUN ("GOM");
  *m = NULL;
  while (!*m)
  {
    /*{{{  Message from ARexx ?*/
    if (*m = (struct Message *)GetARexxMsg ())
    {
      DEBUG_FUN ("Got Arexx Msg");
      if ((struct RexxMsg *)*m==REXX_RETURN_ERROR) *m=NULL;
      rexx_q=1;
    }
    /*}}}  */
    else if (!(*m=GetMsg (OrigamiARexx.MyPort)))
           Wait ((1L<<(OrigamiARexx.ARexxPort->mp_SigBit))
               ||(1L<<(OrigamiARexx.MyPort->mp_SigBit))
               );
    else {DEBUG_FUN ("Got Origami");}
  }
  DEBUG_ENDFUN();
  return (1-rexx_q);
}
/*}}}  */
/*{{{  GetOneMsg_HandleOPort*/
private struct RexxMsg *GetOneMsg_HandleOPort (struct RexxMsg *mm)
{
  struct My_ArexxMessage **mes=NULL;

  DEBUG_NEWFUN ("GOM HOP");
  if (mm) ReplyARexxMsg (mm,"",0);
  while ((!quit)&&(GetOneMsg (mes)))
  /*{{{  handle Origami Port*/
  {
    fprintf (fd,"Type : %d\n",(*mes)->class);
    /*{{{  Not Reply*/
    if ((*mes)->ExecMessage.mn_Node.ln_Type !=NT_REPLYMSG)
    {
      /*{{{  handle different classes*/
      switch ((*mes)->class)
       {
        /*{{{  AREXX_COME_DOWN*/
        case AREXX_COME_DOWN: quit =1;
                              break;
        /*}}}  */
        /*{{{  AREXX_OUT*/
        case AREXX_OUT:
          fprintf (fd,"Message : %s\n",(*mes)->my_message);
          /*{{{  Name*/
          if (strcmp ((*mes)->my_message,"$PORTNAME"))
          {
            print_ori_message (OrigamiARexx.ARexxPortName);
            break;
          }
          /*}}}  */
          /*{{{  Quit*/
          if (strcmp ((*mes)->my_message,"$QUIT"))
          {
            quit = 1;
            break;
          }
          /*}}}  */
          /*{{{  start script*/
          if (!*((*mes)->my_message)) break;
          SendARexxMsg ((*mes)->my_message,0);
          break;
          /*}}}  */
        /*}}}  */
        /*{{{  AREXX_REQUEST*/
        case AREXX_REQUEST: break;
        /*}}}  */
        /*{{{  default : error*/
        default: fprintf (fd,"Unknown Class %ld\n",(*mes)->class);
        /*}}}  */
       }
      /*}}}  */
      ReplyMsg ((struct Message *)*mes);
    }
    /*}}}  */
    else fprintf (fd,"Reply Class : %d\n",(*mes)->class);

    mes = NULL;
  }
  /*}}}  */
  DEBUG_ENDFUN();
  return (struct RexxMsg *)*mes;
}
/*}}}  */
/*}}}  */
/*}}}  */
/*{{{  handle_arg*/
void do_arg_handling(struct ARexxMsg *mm)
{
  DEBUG_NEWFUN ("do_arg_handling");
  DEBUG_ENDFUN ();
}
/*}}}  */

/*{{{  my_exit*/
private void my_exit (int rc)
{
  struct  RexxMsg *rmsg;

  DEBUG_NEWFUN ("my_exit");
  /*{{{  clear portname*/
  OrigamiARexx.ARexxPortName[0]='\0';
  /*}}}  */
  /*{{{  handle outstanding messages*/
  while (OrigamiARexx.Outstanding)
  {
    /*{{{  Wait for all outstanding msg*/
    WaitPort(OrigamiARexx.ARexxPort);
    while (rmsg=GetARexxMsg())
    {
      /*{{{  handle incoming msg*/
      if (rmsg!=REXX_RETURN_ERROR)
      {
        SetARexxLastError(rmsg,"99: Port Closed!");
        ReplyARexxMsg(rmsg,NULL,100);
      }
      /*}}}  */
    }
    /*}}}  */
  }
  /*}}}  */
  /*{{{  clean arexx port*/
  if (OrigamiARexx.ARexxPort)
  {
    /*{{{  handle incoming msg*/
    while (rmsg=GetARexxMsg())
    {
      /*
       * Any messages that still are coming in are
       * "dead"  We just set the LASTERROR and
       * reply an error of 100...
       */
      SetARexxLastError(rmsg,"99: Port Closed!");
      ReplyARexxMsg(rmsg,NULL,100);
    }
    /*}}}  */
    DeletePort(OrigamiARexx.ARexxPort);
  }
  /*}}}  */
  /*{{{  close library*/
  if (OrigamiARexx.RexxSysBase) CloseLibrary(OrigamiARexx.RexxSysBase);
  /*}}}  */
  /*{{{  close my port*/
  if (OrigamiARexx.MyPort) DeletePort (OrigamiARexx.MyPort);
  /*}}}  */
  /*{{{  close window*/
  if (fd) fclose (fd);
  /*}}}  */
  exit (rc);
}
/*}}}  */
/*{{{  InitPorts*/
private void InitPorts (void)
{
  DEBUG_NEWFUN ("InitPorts");
  /*{{{  InitARexx*/
  if (!(OrigamiARexx.RexxSysBase=OpenLibrary("rexxsyslib.library",NULL))) my_exit(1);
  /*Forbid();*/
  /*{{{  Create Portname*/
  strcat (OrigamiARexx.ARexxPortName,OrigamiARexx.OriPid);
  /*}}}  */
  /*{{{  Open Port*/
  if (!(OrigamiARexx.ARexxPort=CreatePort(OrigamiARexx.ARexxPortName,NULL)))
  {
    /*Permit();*/
    my_exit (2);
  }
  /*}}}  */
  /*Permit();*/
  /*}}}  */
  DEBUG_FUN ("end init AREXX");
  /*{{{  InitOrigamiPort (MyPort)*/
  if (OrigamiARexx.MyPort = CreatePort (NULL,0))
   {
    fprintf (fd,"%lx\n",OrigamiARexx.MyPort);
    msg.ExecMessage.mn_Node.ln_Type = NT_MESSAGE;
    msg.ExecMessage.mn_ReplyPort = OrigamiARexx.MyPort;
    msg.ExecMessage.mn_Length = 0;
    msg.class = AREXX_CAME_UP;
    PutMsg (OrigamiARexx.OrigamiPort,(struct Message *)&msg);
   }
  /*}}}  */
  DEBUG_ENDFUN();
}
/*}}}  */
/*{{{  main*/
void main (int argc, char **argv)
{
  struct RexxMsg *msg=NULL;
  int stop=0;

  fd = fopen ("CON:0/0/300/80/OrigamiArexx","w");
  DEBUG_NEWFUN ("main");
  /*{{{  initialize*/
  if (argc != 2) stop = 1;
  /*{{{  Get Origami Port Oxxxxxx*/
  OrigamiARexx.OriPid=argv[1];
  strcat (OrigamiARexx.OrigamiPortName,OrigamiARexx.OriPid);
  if (!stop) if (!(OrigamiARexx.OrigamiPort =
    FindPort (OrigamiARexx.OrigamiPortName))) stop = 1;
  /*}}}  */
  /*{{{  usage*/
  if (stop)
   {
    fprintf (fd,"This program may only be used by origami !\n");
    exit (100);
   }
  /*}}}  */
  InitPorts ();
  /*}}}  */
  DEBUG_FUN("end init");
  /*{{{  main loop*/
  do
  {
    /*{{{  handle one Message*/
    msg = GetOneMsg_HandleOPort (msg);
    if (strcmp (msg->rm_Args[0],"QUIT"))
    {
      do_arg_handling (msg);
      msg=NULL;
    }
    else quit = 2;
    /*}}}  */
  }
  while (!quit);
  /*}}}  */
  DEBUG_FUN("end loop");
  /*{{{  ReplyMessage, if QUIT from ARexx*/
  if (quit==2) /* stoped by QUIT-command */
  {
    ReplyARexxMsg (msg,"",0);
    msg=NULL;
  }
  /*}}}  */
  DEBUG_ENDFUN ();
  my_exit (0);
}
/*}}}  */
