#define RC_READ
/*{{{  readtags*/
typedef enum
 { RC_ENDE,
   RC_M_TAB,
   RC_M_VAR,
   RC_DEFKEY,
   RC_DEFMACRO,
   RC_INITMACRO,
   RC_KEYNAME,
   RC_INTS,
   RC_MARKS,
   RC_BREAK,
   RC_MODE,
   RC_AUTOM,
   RC_BIND,
   RC_ABORTM,
   RC_PROMPTIN,
   RC_PROMPTOUT,
   RC_KNBMAC,
   RC_VMAC,
   RC_MACCOUNT,
   RC_CHARSET,
   RC_S_VAR,
   RC_NO_TITLE,
   RC_TERMALIAS
 } readtags;
/*}}}  */
/*{{{  io-macros for rc-file*/
/*{{{  get*/
#ifdef GETRC
#  define rc_get_c(f)     getc(f)
  /*{{{  rc_get_w*/
  int rc_get_w(FILE *f)
#  ifndef I_RC_CODE
                       ;
#  else
  { int high=getc(f);
    int low=getc(f);
    int neg=(high&0x80)?-1:1;

    return(neg*(((high&0x7f)<<8)+low));
  }
#  endif
  /*}}}  */
#endif
/*}}}  */
/*{{{  put*/
#ifdef PUTRC
#  define rc_put_c(c,f)   putc(c,f)
  /*{{{  rc_put_w*/
  int rc_put_w(int w,FILE *f)
#  ifndef I_RC_CODE
                             ;
#  else
  { int neg;

    if (w<0)
     { neg=0x80;w = -w; }
    else
     { neg=0; }
    if (w & ~0x7fff)
     { fputs("CRASH - OCL-number overflow!\n",stderr);
       exit(1);
     }
    rc_put_c(neg|(w>>8),f);
    rc_put_c(w,f);

    return(0);
  }
#  endif
  /*}}}  */
#endif
/*}}}  */
/*}}}  */
