/*{{{  #includes*/
#ifdef CONFIG_H
#   include "config.h"
#endif

#include <sys/types.h>
#include <ctype.h>
#include <limits.h>
#include <stdlib.h>
#include <stdio.h>

#include <local/bool.h>

#define SET_C
#define I_MESSAGES_C
#define I_SCREEN_C

#include "origami.h"

#define GETRC

#include "../h/rcformat.h"
/*}}}  */

/*{{{  variables*/
private Set *setlist;
/*}}}  */

/*{{{  init_set*/
bool init_set(FILE *rc)
{ int no=rc_get_w(rc);
  int i;

  if (!(setlist=(Set*)malloc(no)))
   { oputs((char *)M_NO_MEMORY);
     oputc('\n');
     return(TRUE);
   }
  no=no>>5;
  while (no--)
     for (i=0;i<sizeof(Set);i++)
        setlist[no][i]=rc_get_c(rc);

  return(FALSE);
}
/*}}}  */
/*{{{  test_char_set*/
bool test_char_set(int x,int setno)
{  switch (setno)
   { case ALPHA: return((bool)isalpha(x));
     case UPPER: return((bool)(isalpha(x)&&isupper(x)));
     case LOWER: return((bool)(isalpha(x)&&islower(x)));
     case DIGIT: return((bool)isdigit(x));
     default:
      { return((bool)((1<<(x&7))&setlist[setno][x>>3]));}
   }
}
/*}}}  */
