/*{{{  possible switches*/
/*
   Use the following configuration symbols to generate a makefile for
   your system with "/usr/lib/cpp -DCONFIG Makefile.cpp >Makefile"

     SUNOS_GCC
     HPUX_ANSI
     LINUX
   Set the variables for unproto to your version of it.
     SUNOS_UNPROTO_CC
     HPUX_UNPROTO
   The following defines are not tested. This version must be compiled with
   ANSI-cc or with uncompile!
     MINIX_BCCi386  (untested)
     MINIX_GCCi386  (untested)
     MIPS           (untested)

*/
/*}}}  */
/*{{{  SUNOS*/
/*{{{  UNPROTO_CC*/
#ifdef SUNOS_UNPROTO_CC
CC=             cc
CPP_DIR=        /home/balu/ourbin/bin.$(ARCHITECTURE)
CFLAGS=         -Qpath $(CPP_DIR) -I.. -D_POSIX_SOURCE
LDFLAGS=
LIBS=
O=              o
#ifndef ORIGAMI_PATH
ORIGAMI_PATH=   $(HOME)/origami
#endif
#ifndef BIN_PATH
BIN_PATH=       $(HOME)/bin$(ARCHITECTURE)
#endif
#endif
/*}}}  */
/*{{{  GCC*/
#ifdef SUNOS_GCC
CC=             gcc
CFLAGS=         -O -ansi -pedantic -Wall -I.. -D_POSIX_MAX_PATH_LEN=256 \
		-D_POSIX_SOURCE
LDFLAGS=
LIBS=
O=              o
#ifndef ORIGAMI_PATH
ORIGAMI_PATH=   $(HOME)/origami
#endif
#ifndef BIN_PATH
BIN_PATH=       $(HOME)/bin$(ARCHITECTURE)
#endif
#endif
/*}}}  */
/*}}}  */
/*{{{  HPUX*/
/*{{{  HPUX_UNPROTO*/
#ifdef HPUX_UNPROTO
CC=             cc
CPP=/home/balu/ourbin/bin.hp/cpp
CFLAGS=         -O -tp,$(CPP) -I.. -D_POSIX_SOURCE
LDFLAGS=
LIBS=
O=              o
#ifndef ORIGAMI_PATH
ORIGAMI_PATH=   $(HOME)/origami
#endif
#ifndef BIN_PATH
BIN_PATH=       $(HOME)/bin$(ARCHITECTURE)
#endif
#endif
/*}}}  */
/*{{{  HPUX_ANSI*/
#ifdef HPUX_ANSI
CC=             cc
CFLAGS=         -Aa -O -I.. -D_POSIX_SOURCE
LDFLAGS=
LIBS=
O=              o
#ifndef ORIGAMI_PATH
ORIGAMI_PATH=   $(HOME)/origami
#endif
#ifndef BIN_PATH
BIN_PATH=       $(HOME)/bin$(ARCHITECTURE)
#endif
#endif
/*}}}  */
/*}}}  */
/*{{{  LINUX*/
#ifdef LINUX
CC=             gcc
CFLAGS=         -I.. -Wall -D_POSIX_SOURCE
LDFLAGS=
LIBS=
O=              o
#ifndef ORIGAMI_PATH
ORIGAMI_PATH=   /usr/local/origami
#endif
#ifndef BIN_PATH
BIN_PATH=       /usr/local/bin
#endif
#endif
/*}}}  */
/*{{{  MINIX*/
/*{{{  BCCi386*/
#ifdef MINIX_BCCi386
CC=             bcc -3
CFLAGS=         -O -D_MINIX -D_POSIX_SOURCE
LDFLAGS=
LIBS=
O=              o
#ifndef ORIGAMI_PATH
ORIGAMI_PATH=   /usr/local/origami
#endif
#ifndef BIN_PATH
BIN_PATH=       /usr/local/bin
#endif
#endif
/*}}}  */
/*{{{  GCCi386*/
#ifdef MINIX_GCCi386
CC=             gcc
CFLAGS=         -O -D_MINIX -D_POSIX_SOURCE -ansi -pedantic  \
		-Wall -DWARNALL
LDFLAGS=
LIBS=
O=              o
#ifndef ORIGAMI_PATH
ORIGAMI_PATH=   /usr/local/origami
#endif
#ifndef BIN_PATH
BIN_PATH=       /usr/local/bin
#endif
#endif
/*}}}  */
/*}}}  */
/*{{{  MIPS*/
#ifdef MIPS
CC=             /posix/bin/cc
CFLAGS=         -I.. -O -D_POSIX_SOURCE
LDFLAGS=
LIBS=
O=              o
#ifndef ORIGAMI_PATH
ORIGAMI_PATH=   $(HOME)/origami
#endif
#ifndef BIN_PATH
BIN_PATH=       $(HOME)/bin
#endif
#endif
/*}}}  */

HDRS=           pager.h ../h/envvar_str.h

OBJS=           main.$(O)

oripager:       $(OBJS)
		$(CC) $(LDFLAGS) -o $@ $(OBJS) $(LIBS)

$(OBJS):        $(HDRS)

install:        oripager
		install -d $(BIN_PATH)
		install oripager $(BIN_PATH)
		strip $(BIN_PATH)/oripager

deinstall:
		rm -f $(BIN_PATH)/oripager

clean:
		rm -f core symbol.out err.out $(OBJS)

clobber:        clean
		rm -f oripager Makefile
